﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.Diagrams.Extensions.ViewModels;
using Telerik.Windows.Diagrams.Core;

namespace DiagramTest
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
		}

		private void Button_Click(object sender, RoutedEventArgs e)
		{
			// This is my old code.
			//////ColumnMappingSourceViewModel columnMappingsourceVM = new ColumnMappingSourceViewModel();
			////RadDiagramContainerShape cc = new RadDiagramContainerShape();
			////cc.IsCollapsible = true;
			////cc.Padding = new Thickness(5, 5, 5, 5);
			////cc.Content = "Extract Columns";
			////cc.UseDefaultConnectors = false;
			////LoadChildren(cc);
			////cc.Name = "SourceContainer";
			////cc.ZIndex = 1;

			////diagram.AddShape(cc);

			////////ColumnMappingDestinationViewModel columnMappingDestinationVM = new ColumnMappingDestinationViewModel();

			////RadDiagramContainerShape cc2 = new RadDiagramContainerShape();
			////cc2.Name = "DestinationContainer";
			////cc2.IsCollapsible = true;
			////cc2.Padding = new Thickness(5, 5, 5, 5);
			////cc2.Content = "Maps To Columns";
			////cc2.Position = new Point(300, 0);
			////LoadChildren(cc2);
			//////cc2.ItemsSource = columnMappingDestinationVM.TreeItems;
			////cc2.UseDefaultConnectors = false;
			////cc2.ZIndex = 1;

			////diagram.AddShape(cc2);

			// This is your code and it will work, but you won't be able to drag an item out of the container.
			////ColumnMappingDestinationContainerViewModel columnMappingDestinationVM = new ColumnMappingDestinationContainerViewModel();
			////RadDiagramContainerShape cc2 = new RadDiagramContainerShape();
			////cc2.Name = "DestinationContainer";
			////cc2.IsCollapsible = true;
			////cc2.Padding = new Thickness(5, 5, 5, 5);
			////cc2.Content = "Maps To Columns";
			////cc2.Position = new Point(300, 0);
			//////LoadChildren(cc2);
			////cc2.ItemsSource = columnMappingDestinationVM.Items;
			////cc2.UseDefaultConnectors = false;
			////cc2.ZIndex = 1;

			////diagram.AddShape(cc2);

			ColumnMappingDestinationContainerViewModel columnMappingDestinationVM = new ColumnMappingDestinationContainerViewModel();
			var cc2 = new MyContainer();
			cc2.IsCollapsible = true;
			cc2.Padding = new Thickness(5, 5, 5, 5);
			cc2.Content = "Maps To Columns";
			cc2.Position = new Point(300, 0);
			cc2.InnerItems = columnMappingDestinationVM.Items;
			cc2.UseDefaultConnectors = false;
			cc2.ZIndex = 1;

			diagram.Items.Add(cc2);
		}

		private void LoadChildren(RadDiagramContainerShape cc)
		{
			for (int i = 0; i < 10; i++)
			{
				cc.Items.Add(new RadDiagramShape() { Content = "This is a child of " + cc.Content, Position = new Point(cc.Position.X, cc.Position.Y + i * 50) });
			}
		}
	}

	public class MyContainer : NodeViewModelBase, IContainerItem
	{
		private ObservableCollection<ItemViewModelBase> items;
		private bool isCollapsible;
		private bool useDefaultConnectors;
		private int zIndex;
		private Thickness padding;


		public ObservableCollection<ItemViewModelBase> InnerItems
		{
			get
			{
				return this.items;
			}
			set
			{
				this.items = value;
			}
		}
		public System.Collections.IEnumerable Items
		{
			get { return this.items; }
		}
		public Thickness Padding
		{
			get
			{
				return this.padding;
			}
			set
			{
				if (this.padding != value)
				{
					this.padding = value;
					this.OnPropertyChanged("Padding");
				}
			}
		}
		public int ZIndex
		{
			get
			{
				return this.zIndex;
			}
			set
			{
				if (this.zIndex != value)
				{
					this.zIndex = value;
					this.OnPropertyChanged("ZIndex");
				}
			}
		}
		public bool UseDefaultConnectors
		{
			get
			{
				return this.useDefaultConnectors;
			}
			set
			{
				if (this.useDefaultConnectors != value)
				{
					this.useDefaultConnectors = value;
					this.OnPropertyChanged("UseDefaultConnectors");
				}
			}
		}
		public bool IsCollapsible
		{
			get
			{
				return this.isCollapsible;
			}
			set
			{
				if (this.isCollapsible != value)
				{
					this.isCollapsible = value;
					this.OnPropertyChanged("IsCollapsible");
				}
			}
		}

		public bool AddItem(object item)
		{
			this.items.Add(item as ItemViewModelBase);
			return true;
		}
		public bool RemoveItem(object item)
		{
			return this.items.Remove(item as ItemViewModelBase);
		}
	}

	public class ColumnMappingDestinationContainerViewModel
	{
		public ColumnMappingDestinationContainerViewModel()
		{
			Items = new ObservableCollection<ItemViewModelBase>();

			for (int i = 1; i < 20; i++)
			{
				NodeViewModelBase fakeItem = new NodeViewModelBase();
				fakeItem.Position = new Point(300, 45 * i);
				fakeItem.Content = "DestinationColumn" + i.ToString();
				fakeItem.Visibility = System.Windows.Visibility.Visible;
				Items.Add(fakeItem);
			}
		}

		public ObservableCollection<ItemViewModelBase> Items
		{
			get;
			private set;
		}
	}
}
